#include <amxmodx>
#include <colorchat>
#include <cstrike>
#include <csx>
#include <engine>
#include <fakemeta>
#include <fun>
#include <hamsandwich>

new Array:g_Array, CsArmorType:armortype, bool:g_FreezeTime, bool:g_Vip[33], skoki[33],
weapon_id;

new const g_Langcmd[][]={"say /vips","say_team /vips","say /vipy","say_team /vipy"};

public plugin_init(){
	register_plugin("VIP Ultimate", "5.1.0.2", "benio101 & speedkill");
	RegisterHam(Ham_Spawn, "player", "SpawnedEventPre", 1);
	RegisterHam(Ham_Item_PreFrame, "player", "fw_Player_ResetMaxSpeed", 1);
	register_logevent("logevent_round_start", 2, "1=Round_Start");
	register_event("HLTV", "event_new_round", "a", "1=0", "2=0");
	register_forward(FM_CmdStart, "CmdStartPre");
	register_message(get_user_msgid("ScoreAttrib"), "g_VipStatus");
	g_Array=ArrayCreate(64,32);
	for(new i;i<sizeof g_Langcmd;i++)
		register_clcmd(g_Langcmd[i],"g_Vips");
	register_clcmd("say /vip", "g_ShowMotd");
	register_event("DeathMsg", "DeathMsg", "a");
}
public client_authorized(id){
	if(get_user_flags(id) & 524288 == 524288){
		client_authorized_vip(id);
	}
}
public client_authorized_vip(id){
	g_Vip[id]=true;
	new g_Name[64];
	get_user_name(id,g_Name,charsmax(g_Name));
	ArrayPushString(g_Array,g_Name);
}
public client_disconnect(id){
	if(g_Vip[id]){
		client_disconnect_vip(id);
	}
}
public client_disconnect_vip(id){
	g_Vip[id]=false;
	new Name[64];
	get_user_name(id,Name,charsmax(Name));

	new g_Size = ArraySize(g_Array);
	new g_Name[64];

	for(new i = 0; i < g_Size; i++){
		ArrayGetString(g_Array, i, g_Name, charsmax(g_Name));

		if(equal(g_Name,Name)){
			ArrayDeleteItem(g_Array,i);
		}
	}
}
public SpawnedEventPre(id){
	if(g_Vip[id]){
		if(is_user_alive(id)){
			SpawnedEventPreVip(id);
		}
	}
}
public SpawnedEventPreVip(id){
	set_user_gravity(id, 0.8125);
	set_user_rendering(id, kRenderFxNone, 0,0,0, kRenderTransAlpha, 222);
	skoki[id]=2;
	set_user_health(id, get_user_health(id)+25);
	cs_set_user_armor(id, min(cs_get_user_armor(id,armortype)+125, 125), armortype);
	cs_set_user_money(id, min(cs_get_user_money(id)+500, 16000), 1);
	give_item(id, "weapon_hegrenade");
	cs_set_user_bpammo(id, CSW_HEGRENADE,3);
	give_item(id, "weapon_flashbang");
	give_item(id, "weapon_smokegrenade");
	cs_set_user_bpammo(id, CSW_SMOKEGRENADE,2);
	new g_Model[64];
	formatex(g_Model,charsmax(g_Model),"%s",get_user_team(id) == 1 ? "vip-TT" : "vip-CT");
	cs_set_user_model(id,g_Model);
	if(get_user_team(id)%3){
		give_item(id, "weapon_deagle");
		give_item(id, "ammo_50ae");
		weapon_id=find_ent_by_owner(-1, "weapon_deagle", id);
		if(weapon_id)cs_set_weapon_ammo(weapon_id, 7);
		cs_set_user_bpammo(id, CSW_DEAGLE, 35);
	}
	if(get_user_team(id)==1){
		give_item(id, "weapon_ak47");
		give_item(id, "ammo_762nato");
		weapon_id=find_ent_by_owner(-1, "weapon_ak47", id);
		if(weapon_id)cs_set_weapon_ammo(weapon_id, 30);
		cs_set_user_bpammo(id, CSW_AK47, 90);
		cs_set_user_nvg(id);
	}
	if(get_user_team(id)==2){
		give_item(id, "weapon_m4a1");
		give_item(id, "ammo_556nato");
		weapon_id=find_ent_by_owner(-1, "weapon_m4a1", id);
		if(weapon_id)cs_set_weapon_ammo(weapon_id, 30);
		cs_set_user_bpammo(id, CSW_M4A1, 90);
		give_item(id, "item_thighpack");
	}
}
public fw_Player_ResetMaxSpeed(id){
	if(g_Vip[id]){
		if(is_user_alive(id)){
			fw_Player_ResetMaxSpeedVip(id);
		}
	}
}
public logevent_round_start(){
	g_FreezeTime=false;
}
public event_new_round(){
	g_FreezeTime=true;
}
public fw_Player_ResetMaxSpeedVip(id){
	if(!g_FreezeTime){
		set_user_maxspeed(id,get_user_maxspeed(id) + 50);
	}
}
public CmdStartPre(id, uc_handle){
	if(g_Vip[id]){
		if(is_user_alive(id)){
			CmdStartPreVip(id, uc_handle);
		}
	}
}
public CmdStartPreVip(id, uc_handle){
	new flags = pev(id, pev_flags);
	if((get_uc(uc_handle, UC_Buttons) & IN_JUMP) && !(flags & FL_ONGROUND) && !(pev(id, pev_oldbuttons) & IN_JUMP) && skoki[id]>0){
		--skoki[id];
		new Float:velocity[3];
		pev(id, pev_velocity,velocity);
		velocity[2] = random_float(265.0,285.0);
		set_pev(id,pev_velocity,velocity);
	} else if(flags & FL_ONGROUND && skoki[id]!=-1){
		skoki[id] = 2;
	}
}
public g_VipStatus(){
	new id=get_msg_arg_int(1);
	if(is_user_alive(id) && g_Vip[id])
		set_msg_arg_int(2, ARG_BYTE, get_msg_arg_int(2)|4);
}
public g_Vips(id){
	new g_Name[64],g_Message[192];

	new g_Size=ArraySize(g_Array);

	for(new i = 0; i < g_Size; i++){
		ArrayGetString(g_Array, i, g_Name, charsmax(g_Name));

		add(g_Message, charsmax(g_Message), g_Name);

		if(i == g_Size - 1)
			add(g_Message, charsmax(g_Message), ".");
		else
			add(g_Message, charsmax(g_Message), ", ");
	}
	ColorChat(id,GREEN,"^x03Vipy ^x04na ^x03serwerze : ^x04%s", g_Message);
}
public client_infochanged(id){
	if(g_Vip[id]){
		new szName[64];
		get_user_info(id,"name",szName,charsmax(szName));

		ArrayPushString(g_Array,szName);

		new Name[64];
		get_user_name(id,Name,charsmax(Name));

		new g_Size=ArraySize(g_Array);
		new g_Name[64];

		for(new i = 0; i < g_Size; i++){
			ArrayGetString(g_Array, i, g_Name, charsmax(g_Name));

			if(equal(g_Name,Name)){
				ArrayDeleteItem(g_Array,i);
			}
		}
	}
}
public plugin_end(){
	ArrayDestroy(g_Array);
}
public g_ShowMotd(id){
	if(is_user_connected(id))
		show_motd(id, "vip.txt", "Informacje o vipie");
}
public bomb_planted(id){
	if(is_user_alive(id) && g_Vip[id])
		cs_set_user_money(id,cs_get_user_money(id) + 250);
}
public bomb_defused(id){
	if(is_user_alive(id) && g_Vip[id])
		cs_set_user_money(id,cs_get_user_money(id) + 250);
}
public plugin_precache(){
	precache_model("models/player/vip-CT/vip-CT.mdl");
	precache_model("models/player/vip-TT/vip-TT.mdl");
}
public DeathMsg(){
	new killer=read_data(1);
	new victim=read_data(2);

	if(is_user_alive(killer) && g_Vip[killer]){
		if(get_user_team(killer) != get_user_team(victim)){
			new g_Hs=read_data(3);
			new g_Hp=get_user_health(killer);
			if(g_Hs){	
				cs_set_user_money(killer,cs_get_user_money(killer) + 500);	
				if(g_Hp < 125){
					if(g_Hp + 30 > 125){
						new g_Dif = 125 - g_Hp;
						set_user_health(killer,g_Hp + g_Dif);
					}
					else
						set_user_health(killer,g_Hp + 30);
				}	
			}
			else{	
				cs_set_user_money(killer,cs_get_user_money(killer) + 300);	
				if(g_Hp < 125){
					if(g_Hp + 15 > 125 ){
						new g_Dif = 125 - g_Hp;
						set_user_health(killer,g_Hp + g_Dif);
					}
					else
						set_user_health(killer,g_Hp + 15);
				}
			}
		}
	}
}

public amxbans_admin_connect(id){
                client_authorized(id);
}